﻿using UnityEngine;
using System.Collections;

public class GamFlow : MonoBehaviour {

	public GameObject ui;
	public Player player;

	// Story objects:
	// level 1
	public GameObject secondDoor;
	public GameObject firstDoor;
	public FadeToBlack fadeBlackPlate;
	// level 2
	public GameObject trees;
	public GameObject briefcase;

	// Use this for initialization
	void Start () {
	
	}
	
	// Update is called once per frame
	void Update () {
	
	}

	// game item reporting collision
	public void reportCollision(string name){
		// Level1
		Debug.Log ("REPORT: " + name);
		if(name.Equals("FirstObstacle")){
			Debug.Log ("FIRST");
			iTween.MoveBy(firstDoor, iTween.Hash("x", 1.1f, "time", 1));
		}
		if(name.Equals("SecondObstacle")){
			stopMovement();
			Application.ExternalCall("TwineDisplay", "second door");
		}
		if(name.Equals("ThirdObstacle")){
			stopMovement();
			Application.ExternalCall("TwineDisplay", "briefcase");
		}

		// Level 2
		if(name.Equals("TreesObstacle")){
			Application.ExternalCall("TwineDisplay", "trees");
		}
		if(name.Equals("WrongWayObstacle")){
			Application.ExternalCall("TwineDisplay", "mm lost");
		}
		if(name.Equals("HintObstacle")){
			Application.ExternalCall("TwineDisplay", "mm straight");
		}
		if(name.Equals("BriefcaseObstacle")){
			Application.ExternalCall("TwineDisplay", "mm briefcase");
		}
		if(name.Equals("LithObstacle1")){
			Application.ExternalCall("TwineDisplay", "Lith1");
		}
		if(name.Equals("LithObstacle2")){
			Application.ExternalCall("TwineDisplay", "Lith2");
		}
		if(name.Equals("FinalLithObstacle")){
			Application.ExternalCall("TwineDisplay", "LithFinal");
		}
	}

	public void stopMovement(){
		ui.SetActive(false);
		player.allowMovement = false;
	}

	public void startMovement(){
		ui.SetActive(true);
		player.allowMovement = true;
	}

	void exploreTrain(){
		startMovement();
	}

	void openSecondDoor(){
		startMovement();
		iTween.MoveBy(secondDoor, iTween.Hash("x", 1.1f, "time", 1));
	}

	void removeTrees(){
		startMovement();
		trees.SetActive(false);
		briefcase.SetActive(false);
	}

	public void fadeToBlack(){
		fadeBlackPlate.gameObject.SetActive(true);
	}

	public void nextLevel(){
		Application.LoadLevel("Scene2");
	}
	                         
}
